/**
 * @file      encoder.c
 * @author    2020 Shoji Yamamoto
 * ===============================================================
 * ALT-Groovy-Quatro (Version 1.0.0)
 * Copyright (c) 2020 Shoji Yamamoto
 * ===============================================================
 * The MIT License : https://opensource.org/licenses/MIT
 *
 * Copyright (c) 2020 Shoji Yamamoto
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

#include <stdint.h>
#include <xc.h>
#include "encoder.h"
#include "encoder_template.h"
#include "led.h"

ENCODER_TEMPLATE_GENERATE(0)
ENCODER_TEMPLATE_GENERATE(1)
ENCODER_TEMPLATE_GENERATE(2)
ENCODER_TEMPLATE_GENERATE(3)

void encoder_init(void) {
    ENCODER_SETUP_ANSEL();
    ENCODER_TEMPLATE_GENERATE_INIT(0);
    ENCODER_TEMPLATE_GENERATE_INIT(1);
    ENCODER_TEMPLATE_GENERATE_INIT(2);
    ENCODER_TEMPLATE_GENERATE_INIT(3);
}

void encoder_isr(void) {
    uint8_t encoder_port = ENCODER_PORT;
    ENCODER_TEMPLATE_GENERATE_ISR(0, encoder_port);
    ENCODER_TEMPLATE_GENERATE_ISR(1, encoder_port);
    ENCODER_TEMPLATE_GENERATE_ISR(2, encoder_port);
    ENCODER_TEMPLATE_GENERATE_ISR(3, encoder_port);
}
